package com.lj.pointgrowth.config;

import com.alibaba.fastjson.JSON;
import com.lj.pointgrowth.repository.UserGrowthLogRepository;
import com.lj.pointgrowth.repository.UserPointLogRepository;
import com.lj.pointgrowth.pojo.UserGrowthLog;
import com.lj.pointgrowth.pojo.UserPointLog;
import org.apache.kafka.clients.consumer.ConsumerRecord;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.kafka.annotation.KafkaListener;
import org.springframework.kafka.support.Acknowledgment;
import org.springframework.stereotype.Component;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;


/**
 * @author 黄树文
 * @date 2020/1/15 16:28
 */
public class KafkaListeners {

    private final Logger logger = LoggerFactory.getLogger(this.getClass());

    @Autowired
    private UserPointLogRepository userPointLogRepository;

    @Autowired
    private UserGrowthLogRepository userGrowthLogRepository;


    @KafkaListener(topics = {"userPointLog"}, containerFactory = "batchFactory")
    public void listen(List<ConsumerRecord<?, ?>> records, Acknowledgment ack) throws IOException {
//        logger.info(String.valueOf(records.size()));
//        logger.info("批量监听------userPointLog");
        ArrayList<UserPointLog> userPointLogs = new ArrayList<>();
        for (ConsumerRecord<?, ?> record : records) {
            UserPointLog userPointLog = JSON.parseObject(record.value().toString(), UserPointLog.class);
            userPointLogs.add(userPointLog);
        }
        userPointLogRepository.saveAll(userPointLogs);
        ack.acknowledge();//手动提交偏移量
    }

    @KafkaListener(topics = {"userGrowthLog"}, containerFactory = "batchFactory")
    public void listen2(List<ConsumerRecord<?, ?>> records, Acknowledgment ack) throws IOException {
//        logger.info(String.valueOf(records.size()));
//        logger.info("批量监听------userGrowthLog");
        ArrayList<UserGrowthLog> userGrowthLogs = new ArrayList<>();
        for (ConsumerRecord<?, ?> record : records) {
            UserGrowthLog userGrowthLog = JSON.parseObject(record.value().toString(), UserGrowthLog.class);
            userGrowthLogs.add(userGrowthLog);
        }
        userGrowthLogRepository.saveAll(userGrowthLogs);
        ack.acknowledge();//手动提交偏移量
    }

}
