package com.lj.pointgrowth.pojo;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;

import java.io.Serializable;
import java.util.Date;


import com.baomidou.mybatisplus.extension.activerecord.Model;
import lombok.Data;
import lombok.experimental.Accessors;

/**
 * <p>
 *
 * </p>
 *
 * @author hsw
 * @since 2019-11-28
 */
@Data
@Accessors(chain = true)
@TableName(value = "Mall.dbo.Orders")
public class Orders extends Model<Orders> {

    private static final long serialVersionUID = 1L;

    /**
     * 订单编号
     */
    @TableId(value = "OrdersCode", type = IdType.INPUT)
    private String OrdersCode;
    /**
     * 创建时间
     */
    private Date CreationDate;
    /**
     * 最后修改时间
     */
    private Date LastModified;
    /**
     * 会员Id
     */
    private String AccountId;
    /**
     * 会员名称
     */
    private String AccountName;
    /**
     * 收货人
     */
    private String Consignee;
    /**
     * 邮政编码
     */
    private String DeliveryZipCode;
    /**
     * 发票抬头
     */
    private String Invoice;
    private String InvoiceNo;
    /**
     * 快递备注
     */
    private String OrderNotes;
    /**
     * 订单金额
     */
    private Integer Sum;
    private Integer InitSum;
    /**
     * 产品成本
     */
    private Integer ProductCost;
    private Integer Reducing;
    private Integer Discountprice;
    /**
     * 支付类型
     */
    private Integer PaymentType;
    /**
     * 发货类型
     */
    private Integer DeliveryType;
    /**
     * 订单时间
     */
    private Date OrderTime;
    /**
     * 发货时间
     */
    private Date ShippingTime;
    /**
     * 签收时间
     */
    private Date ReceivingTime;
    /**
     * 发货单号
     */
    private String ShippingNo;
    /**
     * 待确认		0
     * <p>
     * H确认有效	10
     * H医师审核	20
     * H待业务审核	30
     * H等待发货	40
     * H收到商品	50
     * H拒收商品	60
     * H收到款项	70
     * H退货完成	80
     * <p>
     * K收到款项	100
     * K确认有效	110
     * K医师审核	120
     * K待业务审核	130
     * K确认发货	140
     * K收到商品订单完成150
     * K用户拒收商品	160
     * K收到退货	170
     * K退款成功	180
     * <p>
     * 取消订单	200
     */
    private Integer OrderStatus;
    private Boolean IsReturn;
    /**
     * 运费
     */
    private Integer TransportCosts;
    /**
     * 区域编码
     */
    private String RegionCode;
    /**
     * 是否处方药
     */
    private Boolean IsRxDrug;
    /**
     * 来源类型:
     * 1：客户自主
     * 2：商务通
     * 3：电话
     * 4：qq
     * 5：淘宝B店
     * 6：淘宝C店
     * 7：淘宝聚划算
     * 8：拍拍
     * 9：五八团购
     */
    private Integer OriginType;
    /**
     * 自主下单人
     */
    private String OperateID;
    /**
     * 部门Id
     */
    private String DeptId;
    /**
     * 部门编码
     */
    private String DeptCode;
    /**
     * 客户Id
     */
    private String BuyUserId;
    /**
     * 订单所属产品线：
     * 1：健客网
     * 2：药妆
     * 3：补肾壮阳
     * 4：减肥瘦身
     */
    private String ProductLine;
    /**
     * 订单所属子产品线：
     * 11：健客网
     * 21：上宫庄
     * 31：毕挺
     * 41：绿青
     * 42：左旋咖啡
     * 43：露卡素
     * 44：P57
     * 45：挺靓
     */
    private String SubProductLine;
    private String DiseaseClassCode;
    private Date Age;
    private String Sex;
    /**
     * 同步状态
     */
    private String SyncStatus;
    /**
     * 是否显示订单
     */
    private Boolean IsVisible;
    private Integer ErrorCount;
    private Boolean IsNeedReceipt;
    private Integer OrdersIntegral;
    private Integer CouponCode;
    private Integer CouponValue;
    private Boolean Ispayment;
    private String AuditorId;
    private Date AllocationTime;
    private Integer SourcePlatforms;
    private Integer DeviceType;
    private Boolean IsReward;
    private Boolean IsEmailmark;
    private String CustomerDataId;
    private Boolean IsDrug;
    private Integer HuaWuOriginType;
    private Integer InvoiceSum;
    private Integer AdvanceSum;
    private Integer AgainOrderCount;
    private Integer ConfimLevel;
    private String BusinessId;
    private Boolean IsPayByCard;
    private Double PreferentialRate;
    private String VerificationCode;
    private String AConsigneePhone1;
    private String AConsigneePhone2;
    private String AConsigneePhone3;
    private String ADeliveryAddress;
    private Boolean IsAutomaticSigned;
    private Integer WarehouseCode;
    private Integer CashCouponValue;
    private String CashCouponCode;
    private Boolean IsDealWith;
    private Boolean IsNewOrder;
    private Integer ConsigneeType;
    private String CustomerCode;
    private String CustomerName;
    private String InvoiceContent;
    private Integer InvoiceContentType;
    private Integer OrdersType;
    private String Weight;
    private String Height;
    private Integer HealthPrice;
    /**
     * 营业员的编号
     */
    private String LeverNumber;
    /**
     * 是否o2o客户的订单 true：是 false:否
     */
    private Boolean IsO2O;
    private Integer AdvancePayType;
    private Date InventoryAuditDate;
    private Date OrderProcessDate;
    private Boolean AllocationFlag;
    private Date BonusDate;
    private Integer IntegralValue;
    private String IsToERP;
    private String MerchantNote;
    private String OtherNote;
    private Boolean IsPrescription;
    private String ConfirmId;
    private Boolean OrderType;
    private Boolean OrderFlag;
    private String WXReceiptCode;


    @Override
    protected Serializable pkVal() {
        return this.OrdersCode;
    }

}
