package com.lj.pointgrowth.quaetz;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.scheduling.quartz.SchedulerFactoryBean;

@Configuration
public class QuartzConfigration {

    /**
     * attention:
     * Details：定义quartz调度工厂
     */


    @Autowired
    private JobFactory jobFactory;


    @Bean(name = "schedulerFactoryBean")
    public SchedulerFactoryBean schedulerFactory() {
        SchedulerFactoryBean factory = new SchedulerFactoryBean();
        // 用于quartz集群,QuartzScheduler 启动时更新己存在的Job
        factory.setOverwriteExistingJobs(true);
        // 延时启动，应用启动1秒后
        factory.setStartupDelay(1);
        // 注册触发器
//        bean.setTriggers(cronJobTrigger);
        factory.setJobFactory(jobFactory);
        return factory;
    }
}
