package com.lj.pointgrowth.schedule;

import com.lj.pointgrowth.service.*;
import org.quartz.Job;
import org.quartz.JobExecutionContext;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Configuration;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.stereotype.Component;

import java.io.IOException;
import java.io.Serializable;
import java.sql.SQLException;
import java.util.concurrent.ExecutionException;

@Component
@Configuration
@EnableScheduling
public class ScheduledJob implements Job, Serializable {


    @Autowired
    private PointGrowthCalculateService pointGrowthCalculateService;


    @Override
    public void execute(JobExecutionContext jobExecutionContext) {
        try {
            pointGrowthCalculateService.pointGrowthCalculate(jobExecutionContext);
        } catch (IOException | ExecutionException | InterruptedException | SQLException | NoSuchFieldException | InstantiationException | IllegalAccessException e) {
            e.printStackTrace();
        }
    }
}
