package com.lj.pointgrowth.service.impl;

import com.baomidou.dynamic.datasource.annotation.DS;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.lj.pointgrowth.mapper.OrdersMapper;
import com.lj.pointgrowth.pojo.Orders;
import com.lj.pointgrowth.service.OrdersService;
import com.lj.pointgrowth.vo.OrdersVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.sql.SQLException;
import java.util.List;

/**
 * <p>
 * 服务实现类
 * </p>
 *
 * @author hsw
 * @since 2019-11-28
 */
@Service
@DS("slave_1")
public class OrdersServiceImpl extends ServiceImpl<OrdersMapper, Orders> implements OrdersService {


    @Autowired
    private OrdersMapper ordersMapper;


    @Override
    public List<OrdersVo> getOrdersByTerminalVo(Integer terminalCode) throws SQLException, IllegalAccessException, NoSuchFieldException, InstantiationException {

        List<OrdersVo> ordersVos = ordersMapper.findOrdersByTerminalVo(terminalCode);

        return ordersVos;
    }

    @Override
    public Integer getNumOfOrdersByTerminalVo(Integer terminalCode) {

        return ordersMapper.getNumOfOrdersByTerminalVo(terminalCode);

    }


}
