package com.lj.pointgrowth.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.lj.pointgrowth.mapper.PointGrowthRuleMapper;
import com.lj.pointgrowth.pojo.PointGrowthRule;
import com.lj.pointgrowth.service.PointGrowthRuleService;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 * 服务实现类
 * </p>
 *
 * @author hsw
 * @since 2019-11-28
 */
@Service
public class PointGrowthRuleServiceImpl extends ServiceImpl<PointGrowthRuleMapper, PointGrowthRule> implements PointGrowthRuleService {

    @Override
    public List<PointGrowthRule> findAll() {

        List<PointGrowthRule> pointGrowthRules = this.baseMapper.findAll();

        for (PointGrowthRule pointGrowthRule : pointGrowthRules) {
            switch (pointGrowthRule.getTimeTaskCycle()) {
                case "test":
                    pointGrowthRule.setTimeTaskCycle("0/5 * * * * ?");
                    break;
                case "test1":
                    pointGrowthRule.setTimeTaskCycle("0/10 * * * * ?");
                    break;
                case "每1小时":
                    pointGrowthRule.setTimeTaskCycle("0 0 0/1 * * ?");
                    break;
                case "每2小时":
                    pointGrowthRule.setTimeTaskCycle("0 0 0/2 * * ?");
                    break;
                case "每3小时":
                    pointGrowthRule.setTimeTaskCycle("0 30 0/3 * * ?");
                    break;
                case "每6小时":
                    pointGrowthRule.setTimeTaskCycle("0 30 0/6 * * ?");
                    break;
                case "每12小时":
                    pointGrowthRule.setTimeTaskCycle("0 0 0/12 * * ?");
                    break;
                case "每1天":
                    pointGrowthRule.setTimeTaskCycle("0 0 4 * * ?");
                    break;
                case "每3天":
                    pointGrowthRule.setTimeTaskCycle("0 30 15 0/3 * ?");
                    break;
                case "每7天":
                    pointGrowthRule.setTimeTaskCycle("0 30 15 0/7 * ?");
                    break;
                default:
                    pointGrowthRule.setTimeTaskCycle("0 0 4 * * ?");
                    break;
            }
        }

        return pointGrowthRules;

    }

    @Override
    public List<String> findAllIds() {
        return this.baseMapper.findAllIds();
    }

    @Override
    public PointGrowthRule findById(String id) {
        return this.baseMapper.selectById(id);
    }
}
